# cyclonedx.model.service

This set of classes represents the data that is possible about known Services.

Note

See the CycloneDX Schema extension definition https://cyclonedx.org/docs/1.7/xml/#type_servicesType

## Classes

`Service` | Class that models the service complex type in the CycloneDX schema.

## Module Contents

class cyclonedx.model.service.Service(*, name: str, bom_ref: str | cyclonedx.model.bom_ref.BomRef | None = None, provider: cyclonedx.model.contact.OrganizationalEntity | None = None, group: str | None = None, version: str | None = None, description: str | None = None, endpoints: collections.abc.Iterable[cyclonedx.model.XsUri] | None = None, authenticated: bool | None = None, x_trust_boundary: bool | None = None, data: collections.abc.Iterable[cyclonedx.model.DataClassification] | None = None, licenses: collections.abc.Iterable[cyclonedx.model.license.License] | None = None, external_references: collections.abc.Iterable[cyclonedx.model.ExternalReference] | None = None, properties: collections.abc.Iterable[cyclonedx.model.Property] | None = None, services: collections.abc.Iterable[Service] | None = None, release_notes: cyclonedx.model.release_note.ReleaseNotes | None = None)

  Bases: `cyclonedx.model.dependency.Dependable`

  Class that models the service complex type in the CycloneDX schema.

  Note

  See the CycloneDX schema: https://cyclonedx.org/docs/1.7/xml/#type_service

  property provider: cyclonedx.model.contact.OrganizationalEntity | None

    Get the organization that provides the service.

    Returns:

      OrganizationalEntity if set else None

  property group: str | None

    The grouping name, namespace, or identifier. This will often be a shortened, single name of the company or project that produced the service or domain name. Whitespace and special characters should be avoided.

    Returns:

      str if provided else None

  property name: str

    The name of the service. This will often be a shortened, single name of the service.

    Returns:

      str

  property version: str | None

    The service version.

    Returns:

      str if set else None

  property description: str | None

    Specifies a description for the service.

    Returns:

      str if set else None

  property endpoints: SortedSet[XsUri]

    A list of endpoints URI’s this service provides.

    Returns:

      Set of XsUri

  property authenticated: bool | None

    A boolean value indicating if the service requires authentication. A value of true indicates the service requires authentication prior to use.

    A value of false indicates the service does not require authentication.

    Returns:

      bool if set else None

  property x_trust_boundary: bool | None

    A boolean value indicating if use of the service crosses a trust zone or boundary. A value of true indicates that by using the service, a trust boundary is crossed.

    A value of false indicates that by using the service, a trust boundary is not crossed.

    Returns:

      bool if set else None

  property data: SortedSet[DataClassification]

    Specifies the data classification.

    Returns:

      Set of DataClassification

  property licenses: cyclonedx.model.license.LicenseRepository

    A optional list of statements about how this Service is licensed.

    Returns:

      Set of LicenseChoice

  property external_references: SortedSet[ExternalReference]

    Provides the ability to document external references related to the Service.

    Returns:

      Set of ExternalReference

  property services: SortedSet['Service']

    A list of services included or deployed behind the parent service.

    This is not a dependency tree.

    It provides a way to specify a hierarchical representation of service assemblies.

    Returns:

      Set of Service

  property release_notes: cyclonedx.model.release_note.ReleaseNotes | None

    Specifies optional release notes.

    Returns:

      ReleaseNotes or None

  property properties: SortedSet[Property]

    Provides the ability to document properties in a key/value store. This provides flexibility to include data not officially supported in the standard without having to use additional namespaces or create extensions.

    Return:

      Set of Property

  property bom_ref: cyclonedx.model.bom_ref.BomRef

    An optional identifier which can be used to reference the service elsewhere in the BOM. Uniqueness is enforced within all elements and children of the root-level bom element.

    Returns:

      BomRef unique identifier for this Service